<html>
<head>
<title>Using this application</title>
<meta http-equiv="Expires" content="0"> 
<meta http-equiv="Cache-Control" content="must-revalidate"> 
<meta http-equiv="Cache-Control" content="no-cache">
<link rel="stylesheet" type="text/css" href="style.css" />
</head>
<body>
<table width="750" height="64" border="0" cellpadding="5" class="table2">
  <tr align="left" valign="top" bgcolor="#FFFFCC">
    <td width="750" height="13" bgcolor="#F4F4F4"><div align="center" style="font: bold 14 px Verdana">Using this application </div></td>
  </tr>
  <tr align="left" valign="top" bgcolor="#FFFFCC">
    <td height="14" bgcolor="#FFFFE1"><p>1. <a href="#purpose">Purpose of this PHP application</a><br>
        2. <a href="#howitworks">How it works
          </a><br>
        3. <a href="#configuration">Configuration of PHP files </a><br>
        4. <a href="#domino">Lotus Domino configuration and LotusScript agent</a><br>
        <br>
        <b><a name="purpose"></a><font color="#993300" size="+1">Purpose of this PHP application</font></b><br>
        This application provides GUI to Lotus Domino mail database. It allows user to view Inbox, Sent and Drafts views. User can also create and send new emails, save new emails as draft, edit and delete existing emails. In the views user can see 100 first documents, viewing more documents or navigating to next documents set is not supported yet. <br>
        Same PHP code can with some adjustments be used to access other databases than mail. <br>
        <br>
        <br>
        <b><a name="howitworks" id="howitworks"></a><font color="#993300" size="+1">How it works</font></b><br>
    These are the steps  application takes to show Inbox view:<br>
    <br>
    <b>1. Obtain session cookie from Domino server or use previously obtained cookie.</b><br>
     If the cookie already exists (which can happen if the user has already logged in), check if that cookie is still valid and if it is go directly to the requested view.<br>
     <br>
     <b>2. Determine if Domino session cookie is still valid </b><br>
    a)
    In case the session cookie exists, but has expired on Domino server, any request from our application will generate the Domino  login screen. The PHP application recognises that Domino server is requesting user login and presents it's own login screen to the user. <br>
    b) 
    In case Domino session cookie does not exist, application sends a request to Domino server to get the XML view and if the response is login form, shows login screen to the user, otherwise it processes the view and presents it in HTML form. <br>
    <br>
    <b>3. Ask user for his Domino username and password </b><br>
    User is presented with a login screen and types his Domino username and password there. <br>
    <br>
    <b>4. Send login request </b><br>
    Application sends a request to the specified Domino database ($url_login) using &quot;?Login&quot; URL command. <br>
    POST http://server.com/db.nsf?Login<br>
    PAYLOAD: username=myname&amp;password=password
    <br>
    <br>
    Note: 
    We could also use GET command for loggin in, but we do not want the username and password to be displayed in the server logs:<br>    
    GET http://server.com/db.nsf?Login&amp;
username=myname&amp;password=password    <br>
    <br>
    <b>5. Process response from login request </b><br>
    The result is either a login screen or the default first page in the database. If the result is not a login screen, we get the session cookie from it (&quot;Set-Cookie&quot; header) and discard the rest of the response. <br>
    <br>
    <b>6. Request the Inbox view</b><br>
    We send request to fetch the Inbox view and append Cookie header with previously received cookie value to that outgoing request. The syntaxt of the request is following: <br>
    POST http://server.com/db.nsf/($Inbox)?ReadViewEntries&amp;Count=100 <br>
    HEADER:<br>
    Cookie: 
    DomAuthSessId=A1234B326353C35353D32563; path=/; <br>
    <br>
    <b>7. Read design of the view to map columns </b><br>
    To determine what are the names of the columns in the fetched XML view, we get the design of the view with URL command ?ReadDesign: http://server.com/db.nsf/($Inbox)?ReadDesign.<br>
    Without this step we would need to point out columns by it's position in the view (1,2,3) instead of using column titles (From, Date, Subject) <br>
    <br>
    <b>8. Process XML from view design and view documents</b><br>
    We use XML parser to find all mail documents in the view and get certain fields from them. Documents in XML source are separated by VIEWENTRY element and fields are separated by ENTRYDATA element. <br>
    <br>
    <b>9. Output HTML back to the web browser</b> <br>
    We create a HTML table and show one mail document per table row.<br>
    <br>
    <br>
    <a name="configuration"></a><font color="#993300" size="+1"><b>Configuration</b></font> <br>
    <br>
    1. URL to be used for logging in <br>
    $url_login = &quot;http://mydominoserver7.com/mail/jdoe.nsf&quot;; <br>
    URL path to obtain session cookie. Can be any database which allows user to open it. This database is used only for initial login (?Login URL command) and is not used for anything else. It can be names.nsf or a dummy database. <br>
    ACL in the database:<br>
    Default: Depositor (or higher)<br>
    Anonymous: No Access
    <br>
    Instead of Default entry, you can specify separate access level for each individual name. <br>
    <br>
    
2. URL to Domino database which contains our LotusScript agent
    <br>
    $url_agentdb = &quot;http://mydominoserver7.com/mail/jdoe.nsf&quot;; <br>
    URL to the database which contains LotusScript agent. Can be any database which a logged in user can open. <br> 
    Read more info in LotusScript Agent section for purpose of the agent.
    <br>
    ACL in the database:<br>
    Default: Author (or higher)<br>
    Anonymous: No Access
    <br>
    Instead of Default entry, you can specify separate access level  for each individual name. <br>
        <br>
        3. Name of the agent used for taking actions on individual documents <br>
        $agent_name=&quot;ProcessDocWebAction&quot;;<br>
        The name of the agent can be changed if needed. The agent must be located in the database specified in $url_agentdb variable. <br>
        <br>
        4. Computed path to mail database of the current user <br>
        $url_maildb = &quot;http://server.com/&quot; . $_SESSION[&quot;MailDB&quot;];<br>
        $_SESSION[&quot;MailDB&quot;] is set from the value received from the LotusScript agent. The agent finds user's document in the server NAB and reads MailFile field value from that document. So the resulting variable is: &quot;http://server.com/mail/jdoe.nsf&quot; . This value is fetched only once and then saved in user's PHP session container. <br>
        Note: We *can* get same value by parsing ($Users) view in names.nsf on server instead of using agent for this, but we use agent for other things anyway, so why not include even this functionality. <br>
        <br>
        <a name="domino"></a><font color="#993300" size="+1"><b>Lotus Domino configuration and LotusScript agent</b></font><br>
        <br>
      LotusScript agent specified in $agent_name variable and by default called &quot;ProcessDocWebAction&quot; is used for: <br>
      - getting path to user's mail database<br>
      - creating new mail documents
      and sending them to recepient <br>
      - getting fields from individual documents thus simulating opening the document<br>
      - saving new documents as draft
      <br>
      - saving existing individual documents after editing them <br>
      <br>
      Agent can be placed in any database which a logged in user can open. Same agent can be used for all users. <br>

ACL of the agent's database:<br>
Default: Author (or higher)<br>
Anonymous: No Access <br>
Instead of Default entry, you can specify separate access level for each individual name. <br>
<br>
For testing purposes you might want to disable sending mails and just save them in the &quot;Sent&quot; view. In this case just comment out the <i>Call maildoc.Send(False)</i> code line. <br>
<br>
<font color="#FF6600">Important:</font> agent must be set to be &quot;Run as web user&quot;. This property ensures that person who triggers the agent can not access unauthorised information in Domino databases even if that person has full control over PHP server and PHP application. <br>
<br>
    </p></td>
  </tr>
</table>
<br>
<font color="#666666" size="1" face="Verdana, Arial, Helvetica, sans-serif">
    <br>
    Created by: <a href="http://www.dominokonsult.se" target="_blank">Andrei Kouvchinnikov</a><br>
    This application is created for demo purposes only <br>
    and not tested in production environment. <br>
    The application is provided &quot;AS IS&quot; and without any <br>
support or warranty. 
<br>
</font>
</body>
</html>
